HDU 4489 The King’s Ups and Downs(递推)

Description

The king has guards of all different heights. Rather than line them up in increasing or decreasing height order, he wants to line them up so each guard is either shorter than the guards next to him or taller than the guards next to him (so the heights go up and down along the line). For example, seven guards of heights 160, 162, 164, 166, 168, 170 and 172 cm. could be arranged as: 

 

or perhaps:

 

The king wants to know how many guards he needs so he can have a different up and down order at each changing of the guard for rest of his reign. To be able to do this, he needs to know for a given number of guards, n, how many different up and down orders there are: 

For example, if there are four guards: 1, 2, 3,4 can be arrange as: 

1324, 2143, 3142, 2314, 3412, 4231, 4132, 2413, 3241, 1423 

For this problem, you will write a program that takes as input a positive integer n, the number of guards and returns the number of up and down orders for n guards of differing heights. 

Input

The first line of input contains a single integer P, (1 <= P <= 1000), which is the number of data sets that follow. Each data set consists of single line of input containing two integers. The first integer, D is the data set number. The second integer, n (1 <= n <= 20), is the number of guards of differing heights.

Output

For each data set there is one line of output. It contains the data set number (D) followed by a single space, followed by the number of up and down orders for the n guards. 

Sample Input

4
1 1
2 3
3 4
4 20

Sample Output

1 1
2 4
3 10
4 740742376475050

题意:

给出不同高度防护装置的数量,求最少的警卫数量使得站成一排时可以呈现一个波浪形。

思路:

假设这n个人身高为1,2,3…,n,那么我们假设前n-1个人已经排好,把这个身高最高为n的人加入队里,如果我们把高看成1,低看成0,构成的排列看成一个01串,那么在他前面的子序列一定以10结尾,后面的子序列一定以01开头。所以设dp(n)为n个人时的解,f[i][0]为长度为i且结尾是10的情况数,f[i][1]是长度为i且开头是01的情况数。则dp[n]=sum{f[i][0]*f[n-1-i]*c[n-1][i]|0<=i<=n},c[n-1][i]是从n-1个人中挑出i个的组合数。注意到开头为01的话如果把它颠倒那么就一定以10结尾,所以f[i][0]=f[i][1]=dp[i],这样就可以递推答案了。
数组c打表

HDU 4489 The King’s Ups and Downs(递推)_第1张图片

数组dp打表

代码如下:

#include
using namespace std;
typedef long long ll;
const int maxn=20;
int a,n;
ll c[maxn+5][maxn+5];
ll f[maxn+5][2],dp[maxn+5];
void init()
{
	c[0][0]=1;
	for (int i=1;i<=maxn;++i)
        {
		c[i][0]=c[i][i]=1;
		for (int j=1;j

 

你可能感兴趣的:(DP,HDU)